unit mySQL4;

//----------------------------------------------------------------------------------------
// Copyright (c) 2001, 2003 OSWay S.r.l. all rights reserved
//----------------------------------------------------------------------------------------
// Project    
// Unit Name  mySQL
// Created on 25 agosto 2003 - 12:45:50
// Updated on $Date: 2003/11/18 19:32:54 $ by Cristiano Muzi <muzi@osway.com>
// Version    $Revision: 1.1 $
{:
   @Author    Cristiano Muzi <muzi@osway.com>
   @Summary   SummaryText
   @Desc      Conversione delle API di MySQL per la versione 4.014.
              NB: Alcune funzioni vengono linkate dalla libreria libmysqld.dll invece che
              dalla libmysql.dll se si vuole usare la versione embedded di MySql.
              In questo caso si deve definire la $define EmbeddedMySql
}
// History    HistoryText
//----------------------------------------------------------------------------------------


interface

const
  LibMySqlDll = 'libMySql.dll';
{$ifdef EmbeddedMySql}
  LibMySqldDll = 'libMySqld.dll';
{$else}
  LibMySqldDll = 'libMySql.dll';
{$endif}

  NAME_LEN = 64;
  HOSTNAME_LENGTH = 60;
  USERNAME_LENGTH = 16;
  SERVER_VERSION_LENGTH = 60;
  LOCAL_HOST: PChar = 'localhost';
  LOCAL_HOST_NAMEDPIPE: PChar = '.';
  MYSQL_NAMEDPIPE: PChar = 'MySQL';
  MYSQL_SERVICENAME: PChar = 'MySql';
  ER_DUP_ENTRY = 1062;

type
  enum_server_command = (
      COM_SLEEP, COM_QUIT, COM_INIT_DB, COM_QUERY, COM_FIELD_LIST,
      COM_CREATE_DB, COM_DROP_DB, COM_REFRESH, COM_SHUTDOWN,  COM_STATISTICS,
      COM_PROCESS_INFO, COM_CONNECT, COM_PROCESS_KILL, COM_DEBUG, COM_PING,
      COM_TIME, COM_DELAYED_INSERT, COM_CHANGE_USER, COM_BINLOG_DUMP,
      COM_TABLE_DUMP,  COM_CONNECT_OUT, COM_REGISTER_SLAVE,
      COM_END);

const
	NOT_NULL_FLAG = 1;      // Field can't be NULL
	PRI_KEY_FLAG = 2;       // Field is part of a primary key
	UNIQUE_KEY_FLAG = 4;    // Field is part of a unique key
	MULTIPLE_KEY_FLAG = 8;  // Field is part of a key
	BLOB_FLAG = 16;         // Field is a blob
	UNSIGNED_FLAG = 32;     // Field is unsigned
	ZEROFILL_FLAG = 64;     // Field is zerofill
	BINARY_FLAG = 128;

	// The following are only sent to new clients

	ENUM_FLAG = 256;            // field is an enum
	AUTO_INCREMENT_FLAG = 512;  // field is a autoincrement field
	TIMESTAMP_FLAG = 1024;      // Field is a timestamp
	SET_FLAG = 2048;            // field is a set
	NUM_FLAG = 32768;           // Field is num (for clients)
	PART_KEY_FLAG = 16384;      // Intern; Part of some key
	GROUP_FLAG = 32768;         // Intern: Group field
	UNIQUE_FLAG = 65536;        // Intern: Used by sql_yacc

	REFRESH_GRANT = 1;     // Refresh grant tables
	REFRESH_LOG = 2;       // Start on new log file
	REFRESH_TABLES = 4;    // close all tables
	REFRESH_HOSTS = 8;     // Flush host cache
	REFRESH_STATUS = 16;   // Flush status variables
	REFRESH_THREADS = 32;  // Flush status variables
	REFRESH_SLAVE = 64;    // Reset master info and restart slave
												 // thread
	REFRESH_MASTER = 128;  // Remove all bin logs in the index
												 // and truncate the index

	// The following can't be set with mysql_refresh()

	REFRESH_READ_LOCK = 16384;  // Lock tables for read
	REFRESH_FAST = 32768;       // Intern flag
  REFRESH_QUERY_CACHE = 65536;
  REFRESH_QUERY_CACHE_FREE: LongWord = $20000;
  REFRESH_DES_KEY_FILE: LongWord = $40000;
  REFRESH_USER_RESOURCES: LongWord = $80000;

	CLIENT_LONG_PASSWORD = 1;      // new more secure passwords
	CLIENT_FOUND_ROWS = 2;         // Found instead of affected rows
	CLIENT_LONG_FLAG = 4;          // Get all column flags
	CLIENT_CONNECT_WITH_DB = 8;    // One can specify db on connect
	CLIENT_NO_SCHEMA = 16;         // Don't allow database.table.column
	CLIENT_COMPRESS = 32;          // Can use compression protcol
	CLIENT_ODBC = 64;              // Odbc client
	CLIENT_LOCAL_FILES = 128;      // Can use LOAD DATA LOCAL
	CLIENT_IGNORE_SPACE = 256;     // Ignore spaces before '('
	CLIENT_INTERACTIVE = 1024;     // This is an interactive client
	CLIENT_SSL = 2048;             // Switch to SSL after handshake
	CLIENT_IGNORE_SIGPIPE = 4096;  // IGNORE sigpipes
	CLIENT_TRANSACTIONS = 8192;    // Client knows about transactions

	SERVER_STATUS_IN_TRANS = 1;	   // Transaction has started
	SERVER_STATUS_AUTOCOMMIT = 2;  // Server in auto_commit mode

	MYSQL_ERRMSG_SIZE = 200;
	NET_READ_TIMEOUT = 30;       // Timeout on read
	NET_WRITE_TIMEOUT = 60;      // Timeout on write
	NET_WAIT_TIMEOUT = 8*60*60;  // Wait for new query

  MAX_CHAR_WIDTH = 255;
  MAX_BLOB_WIDTH = 8192;

type
	PVio = ^TVio;
	TVio = record
	end;

  my_bool = Byte;
  gptr = PChar;
  my_socket = Integer;

	PNET = ^TNET;
	TNET = record
		vio: PVio;
		buff, buff_end, write_pos, read_pos: pByte;
		fd: my_socket;
    max_packet, max_packet_size: LongWord;
    last_errno, pkt_nr, compress_pkt_nr: LongWord;
    write_timeout, read_timeout, retry_count: LongWord;
		fcntl: longint;
		last_error: array [0..MYSQL_ERRMSG_SIZE - 1] of char;
		error: byte;
		return_errno, compress: my_bool;
		remain_in_buf, length, buf_length, where_b: longword;
		return_status: pLongword;
		reading_or_writing: byte;
		save_char: char;
		no_send_ok: my_bool;  // needed if we are doing several
    query_cache_query: gptr;
	end;

const
	packet_error: longword = $ffffffff;

	FIELD_TYPE_DECIMAL = 0;
	FIELD_TYPE_TINY = 1;
	FIELD_TYPE_SHORT = 2;
	FIELD_TYPE_LONG = 3;
	FIELD_TYPE_FLOAT = 4;
	FIELD_TYPE_DOUBLE = 5;
	FIELD_TYPE_NULL = 6;
	FIELD_TYPE_TIMESTAMP = 7;
	FIELD_TYPE_LONGLONG = 8;
	FIELD_TYPE_INT24 = 9;
	FIELD_TYPE_DATE = 10;
	FIELD_TYPE_TIME = 11;
	FIELD_TYPE_DATETIME = 12;
	FIELD_TYPE_YEAR = 13;
	FIELD_TYPE_NEWDATE = 14;
	FIELD_TYPE_ENUM = 247;
	FIELD_TYPE_SET = 248;
	FIELD_TYPE_TINY_BLOB = 249;
	FIELD_TYPE_MEDIUM_BLOB = 250;
	FIELD_TYPE_LONG_BLOB = 251;
	FIELD_TYPE_BLOB = 252;
	FIELD_TYPE_VAR_STRING = 253;
	FIELD_TYPE_STRING = 254;

	FIELD_TYPE_CHAR = FIELD_TYPE_TINY;      // For compability
	FIELD_TYPE_INTERVAL = FIELD_TYPE_ENUM;  // For compability

type
	enum_field_types = FIELD_TYPE_DECIMAL..FIELD_TYPE_STRING;

const
	PROTOCOL_VERSION = 10;
	MYSQL_SERVER_VERSION = '4.0.14';
  MYSQL_BASE_VERSION = 'mysqld-4.0';
	MYSQL_SERVER_SUFFIX = '';
	FRM_VER = 6;
	MYSQL_VERSION_ID = 40014;
	MYSQL_PORT = 3306;
	MYSQL_UNIX_ADDR = '/tmp/mysql.sock';
  MYSQL_CONFIG_NAME = 'my';
  MYSQL_CHARSET = 'latin1';

type
	PCHARSET_INFO = ^TCHARSET_INFO;
	TCHARSET_INFO = record
		// Omitted: Structure not necessarily needed.
		// Definition of struct charset_info_st can be
		// found in include/m_ctype.h
	end;

	PUSED_MEM = ^TUSED_MEM;  // struct for once_alloc
	TUSED_MEM = record
		next: PUSED_MEM;       // Next block in use
		left: longword;        // memory left in block
		size: longword;        // size of block
	end;

	error_proc = procedure; stdcall;

	PMEM_ROOT = ^TMEM_ROOT;
	TMEM_ROOT = record
		free: PUSED_MEM;
		used: PUSED_MEM;
		pre_alloc: PUSED_MEM;
		min_malloc: longword;
		block_size: longword;
		error_handler: error_proc;
	end;

	PMYSQL_LENGTHS = ^TMYSQL_LENGTHS;
	TMYSQL_LENGTHS = array[0..MaxInt div SizeOf(longword) - 1] of longword;

  PMYSQL_FIELD = ^TMYSQL_FIELD;
  TMYSQL_FIELD = packed record
    name: PChar;
    Table: PChar;
    org_table: PChar;
    db: PChar;
    def: PChar;
    length: LongWord;
    max_length: LongWord;
    flags: LongWord;
    decimals: LongWord;
    type_: enum_field_types;
  end;

	PMYSQL_FIELDS = ^TMYSQL_FIELDS;
	TMYSQL_FIELDS = array[0..MaxInt div SizeOf(TMYSQL_FIELD) - 1] of TMYSQL_FIELD;

	PMYSQL_ROW = ^TMYSQL_ROW;  // return data as array of strings
	TMYSQL_ROW = array[0..MaxInt div SizeOf(pChar) - 1] of pChar;

  PArrayOfPChar = PMYSQL_ROW;

  MYSQL_FIELD_OFFSET = LongWord;
  my_ulonglong = Int64;

	PMYSQL_ROWS = ^TMYSQL_ROWS;
	TMYSQL_ROWS = record
		next: PMYSQL_ROWS;  // list of rows
		data: PMYSQL_ROW;
	end;

	MYSQL_ROW_OFFSET = PMYSQL_ROWS;  // offset to current row

	PMYSQL_DATA = ^TMYSQL_DATA;
	TMYSQL_DATA = record
		rows: my_ulonglong;
		fields: longword;
		data: PMYSQL_ROWS;
		alloc: TMEM_ROOT;
	end;
 
	PMYSQL_OPTIONS = ^TMYSQL_OPTIONS;
	TMYSQL_OPTIONS = record
		connect_timeout, client_flag: longword;
//		compress, named_pipe: my_bool;
		port: longword;
		host, init_command, user, password, unix_socket, db: pChar;
		my_cnf_file, my_cnf_group, charset_dir, charset_name: pChar;
//		use_ssl: my_bool;   // if to use SSL or not
		ssl_key: pChar;     // PEM key file
		ssl_cert: pChar;    // PEM cert file
		ssl_ca: pChar;      // PEM CA file
		ssl_capath: pChar;  // PEM directory of CA-s?
    ssl_cipher: PChar;
    max_allowed_packet: LongWord;
    use_ssl: my_bool;
    compress, named_pipe: my_bool;
    rpl_probe: my_bool;
    rpl_parse: my_bool;
    no_master_reads: my_bool;
	end;

  mysql_option = (MYSQL_OPT_CONNECT_TIMEOUT, MYSQL_OPT_COMPRESS, MYSQL_OPT_NAMED_PIPE, MYSQL_INIT_COMMAND,
		    MYSQL_READ_DEFAULT_FILE, MYSQL_READ_DEFAULT_GROUP, MYSQL_SET_CHARSET_DIR, MYSQL_SET_CHARSET_NAME,
		    MYSQL_OPT_LOCAL_INFILE);

  mysql_status = (MYSQL_STATUS_READY, MYSQL_STATUS_GET_RESULT, MYSQL_STATUS_USE_RESULT);

  mysql_rpl_type = (MYSQL_RPL_MASTER, MYSQL_RPL_SLAVE, MYSQL_RPL_ADMIN);

	PMYSQL = ^TMYSQL;
	TMYSQL = record
		net: TNET;                    // Communication parameters
		connector_fd: gptr;           // ConnectorFd for SSL
		host, user, passwd, unix_socket, server_version, host_info, info, db: pChar;
    charset: PCharset_info;
    fields: PMYSQL_FIELDS;
    field_alloc: TMEM_ROOT;
    affected_rows: my_ulonglong;
    insert_id: my_ulonglong;
    extra_info: my_ulonglong;
    thread_id: LongWord;
    packet_length: LongWord;
		port, client_flag, server_capabilities: longword;
		protocol_version: longword;
		field_count: longword;
		server_status: longword;
    server_language: longword;
		options: TMYSQL_OPTIONS;
		status: mysql_status;
		free_me: my_bool;             // If free in mysql_close
		reconnect: my_bool;           // set to 1 if automatic reconnect
		scramble_buff: array [0..8] of char;
    rpl_pivot: my_bool;
    master, next_slave, last_used_slave, last_used_con: PMYSQL;
	end;

	PMYSQL_RES = ^TMYSQL_RES;
	TMYSQL_RES = record
		row_count: my_ulonglong;
		fields: PMYSQL_FIELDS;
		data: PMYSQL_DATA;
		data_cursor: PMYSQL_ROWS;
		lengths: pLongword;       // column lengths of current row
		handle: PMYSQL;           // for unbuffered reads
		field_alloc: TMEM_ROOT;
		field_count, current_field: longword;
		row: PMYSQL_ROW;          // If unbuffered read
		current_row: PMYSQL_ROW;  // buffer to current row
		eof: my_bool;             // Used my mysql_fetch_row
	end;

const
  MAX_MYSQL_MANAGER_ERR = 256;
  MAX_MYSQL_MANAGER_MSG = 256;
  MANAGER_OK =            200;
  MANAGER_INFO =          250;
  MANAGER_ACCESS =        401;
  MANAGER_CLIENT_ERR =    450;
  MANAGER_INTERNAL_ERR =  500;

type
  PMYSQL_MANAGER = ^TMYSQL_MANAGER;
  TMYSQL_MANAGER = record
    net: TNET;
    host, user, passwd: PChar;
    port: LongWord;
    free_me: my_bool;
    eof: my_bool;
    cmd_status: Integer;
    last_errno: Integer;
    net_buf, net_buf_pos, net_data_end: PChar;
    net_buf_size: Integer;
    last_error: array[0..MAX_MYSQL_MANAGER_ERR - 1] of Char;
  end;

	extend_buffer_func = function(void: pointer; _to: pChar; length: pLongword): pChar; stdcall;

const
  rsNFOMySqlUnableToConnect = 's30000: Unable to connect to MySql (mysql_connect failure).';

function MySQLEncodeString(const MySQL: PMySql; const Source: WideString): string;
function MySQLDecodeString(const Source: string): WideString;
function MySQLEncodeDate(const DateTime: TDateTime): string;
function MySQLDecodeDate(const DateTime: string): TDateTime;
function MySqlGetFieldValue(const Row: PMySql_Row; const Lengths: PMySql_Lengths; const Index: Integer): WideString;

{$ifdef EmbeddedMySql}
// Queste funzioni sono definite solo se si usa l'embedded server.
//function mysql_server_init(argc: Integer; var argv: PChar; var groups: PChar): Integer; stdcall; external LibMySqldDll;

function db_connect(database: string = ''): PMySQL;
procedure db_disconnect(MySQL: PMySQL);

function mysql_server_init(argc: Integer; argv, groups: PArrayOfPChar): Integer; stdcall; external LibMySqldDll;
procedure mysql_server_end; stdcall; external LibMySqldDll;

function mysql_thread_init: my_bool; stdcall; external LibMySqldDll;
procedure mysql_thread_end; stdcall; external LibMySqldDll;


function mysql_refresh(_mysql: PMYSQL; refresh_options: longword): longint; stdcall; external LibMySqldDll;
function mysql_create_db(_mysql: PMYSQL; const DB: pChar): longint; stdcall; external LibMySqldDll;
function mysql_drop_db(_mysql: PMYSQL; const DB: pChar): longint; stdcall; external LibMySqldDll;
function mysql_connect(_mysql: PMYSQL; const host, user, passwd: pChar): PMYSQL; stdcall; external LibMySqldDll;
{$endif}

{$ifndef EmbeddedMySql}
// Queste funzioni sono definite solo se si usa il client.
function mysql_ssl_set(_mysql: PMYSQL; const key, cert, ca, capath: pChar): longint; stdcall; external LibMySqldDll;

// perform query on master
function mysql_master_query(mysql: PMYSQL; const q: PChar; length: LongWord): Integer; stdcall; external LibMySqldDll;
function mysql_master_send_query(mysql: PMYSQL; const q: PChar; length: LongWord): Integer; stdcall; external LibMySqldDll;
// perform query on slave
function mysql_slave_query(mysql: PMYSQL; const q: PChar; length: LongWord): Integer; stdcall; external LibMySqldDll;
function mysql_slave_send_query(mysql: PMYSQL; const q: PChar; length: LongWord): Integer; stdcall; external LibMySqldDll;

// enable/disable parsing of all queries to decide if they go on master or slave
procedure mysql_enable_rpl_parse(mysql: PMYSQL); stdcall; external LibMySqldDll;
procedure mysql_disable_rpl_parse(mysql: PMYSQL); stdcall; external LibMySqldDll;
// get the value of the parse flag
function mysql_rpl_parse_enabled(mysql: PMYSQL): Integer; stdcall; external LibMySqldDll;

//  enable/disable reads from master
procedure mysql_enable_reads_from_master(mysql: PMYSQL); stdcall; external LibMySqldDll;
procedure mysql_disable_reads_from_master(mysql: PMYSQL); stdcall; external LibMySqldDll;
// get the value of the master read flag
function mysql_reads_from_master_enabled(mysql: PMYSQL): Integer; stdcall; external LibMySqldDll;

function mysql_rpl_query_type(const q: PChar; len: Integer): mysql_rpl_type; stdcall; external LibMySqldDll;

// discover the master and its slaves
function mysql_rpl_probe(mysql: PMYSQL): Integer; stdcall; external LibMySqldDll;

// set the master, close/free the old one, if it is not a pivot
function mysql_set_master(mysql: PMYSQL; const host: PChar;
					 port: LongWord; const user: PChar; const passwd: PChar): Integer; stdcall; external LibMySqldDll;
function mysql_add_slave(mysql: PMYSQL; const host: PChar;
					port: LongWord; const user: PChar; const passwd: PChar): Integer; stdcall; external LibMySqldDll;


{$endif}

function mysql_real_connect(_mysql: PMYSQL; const host, user, passwd, db: pChar; port: longword; const unix_socket: pChar; clientflag: longword): PMYSQL; stdcall; external LibMySqldDll;
function mysql_num_rows(res: PMYSQL_RES): my_ulonglong; stdcall; external LibMySqldDll;
function mysql_num_fields(res: PMYSQL_RES): longword; stdcall; external LibMySqldDll;
function mysql_eof(res: PMYSQL_RES): my_bool; stdcall; external LibMySqldDll;
function mysql_fetch_field_direct(res: PMYSQL_RES; fieldnr: longword): PMYSQL_FIELD; stdcall; external LibMySqldDll;
function mysql_fetch_fields(res: PMYSQL_RES): PMYSQL_FIELDS; stdcall; external LibMySqldDll;
function mysql_row_tell(res: PMYSQL_RES): PMYSQL_ROWS; stdcall; external LibMySqldDll;
function mysql_field_tell(res: PMYSQL_RES): longword; stdcall; external LibMySqldDll;

function mysql_field_count(_mysql: PMYSQL): longword; stdcall; external LibMySqldDll;
function mysql_affected_rows(_mysql: PMYSQL): my_ulonglong; stdcall; external LibMySqldDll;
function mysql_insert_id(_mysql: PMYSQL): my_ulonglong; stdcall; external LibMySqldDll;
function mysql_errno(_mysql: PMYSQL): longword; stdcall; external LibMySqldDll;
function mysql_error(_mysql: PMYSQL): pChar; stdcall; external LibMySqldDll;
function mysql_info(_mysql: PMYSQL): pChar; stdcall; external LibMySqldDll;
function mysql_thread_id(_mysql: PMYSQL): longword; stdcall; external LibMySqldDll;
function mysql_character_set_name(_mysql: PMYSQL): pChar; stdcall; external LibMySqldDll;


function mysql_init(_mysql: PMYSQL): PMYSQL; stdcall; external LibMySqldDll;
function mysql_change_user(_mysql: PMYSQL; const user, passwd, db: pChar): my_bool; stdcall; external LibMySqldDll;
procedure mysql_close(sock: PMYSQL); stdcall; external LibMySqldDll;
function mysql_select_db(_mysql: PMYSQL; const db: pChar): longint; stdcall; external LibMySqldDll;
function mysql_query(_mysql: PMYSQL; const q: pChar): longint; stdcall; external LibMySqldDll;
function mysql_send_query(_mysql: PMYSQL; const q: pChar; length: longword): longint; stdcall; external LibMySqldDll;
function mysql_read_query_result(_mysql: PMYSQL): longint; stdcall; external LibMySqldDll;
function mysql_real_query(_mysql: PMYSQL; const q: pChar; length: longword): longint; stdcall; external LibMySqldDll;

function mysql_shutdown(_mysql: PMYSQL): longint; stdcall; external LibMySqldDll;
function mysql_dump_debug_info(_mysql: PMYSQL): longint; stdcall; external LibMySqldDll;
function mysql_kill(_mysql: PMYSQL; pid: longword): longint; stdcall; external LibMySqldDll;
function mysql_ping(_mysql: PMYSQL): longint; stdcall; external LibMySqldDll;
function mysql_stat(_mysql: PMYSQL): pChar; stdcall; external LibMySqldDll;
function mysql_get_server_info(_mysql: PMYSQL): pChar; stdcall; external LibMySqldDll;
function mysql_get_client_info: pChar; stdcall; external LibMySqldDll;
function mysql_get_host_info(_mysql: PMYSQL): pChar; stdcall; external LibMySqldDll;
function mysql_get_proto_info(_mysql: PMYSQL): longword; stdcall; external LibMySqldDll;
function mysql_list_dbs(_mysql: PMYSQL; const wild: pChar): PMYSQL_RES; stdcall; external LibMySqldDll;
function mysql_list_tables(_mysql: PMYSQL; const wild: pChar): PMYSQL_RES; stdcall; external LibMySqldDll;
function mysql_list_fields(_mysql: PMYSQL; const table, wild: pChar): PMYSQL_RES; stdcall; external LibMySqldDll;
function mysql_list_processes(_mysql: PMYSQL): PMYSQL_RES; stdcall; external LibMySqldDll;
function mysql_store_result(_mysql: PMYSQL): PMYSQL_RES; stdcall; external LibMySqldDll;
function mysql_use_result(_mysql: PMYSQL): PMYSQL_RES; stdcall; external LibMySqldDll;
function mysql_options(_mysql: PMYSQL; option: mysql_option; const arg: pChar): longint; stdcall; external LibMySqldDll;
procedure mysql_free_result(result: PMYSQL_RES); stdcall; external LibMySqldDll;
procedure mysql_data_seek(result: PMYSQL_RES; offset: my_ulonglong); stdcall; external LibMySqldDll;
function mysql_row_seek(result: PMYSQL_RES; offset: MYSQL_ROW_OFFSET): MYSQL_ROW_OFFSET; stdcall; external LibMySqldDll;
function mysql_field_seek(result: PMYSQL_RES; offset: MYSQL_FIELD_OFFSET): MYSQL_FIELD_OFFSET; stdcall; external LibMySqldDll;
function mysql_fetch_row(result: PMYSQL_RES): PMYSQL_ROW; stdcall; external LibMySqldDll;
function mysql_fetch_lengths(result: PMYSQL_RES): PMYSQL_LENGTHS; stdcall; external LibMySqldDll;
function mysql_fetch_field(result: PMYSQL_RES): PMYSQL_FIELD; stdcall; external LibMySqldDll;
function mysql_escape_string(_to: pChar; const from: pChar; from_length: longword): longword; stdcall; external LibMySqldDll;
function mysql_real_escape_string(_mysql: PMYSQL; _to: pChar; const from: pChar; length: longword): longword; stdcall; external LibMySqldDll;
procedure mysql_debug(const debug: pChar); stdcall; external LibMySqldDll;
function mysql_odbc_escape_string(_mysql: PMYSQL; _to: pChar; to_length: longword; const from: pChar; from_length: longword; param: pointer; extend_buffer: extend_buffer_func): pChar; stdcall; external LibMySqldDll;
procedure myodbc_remove_escape(_mysql: PMYSQL; name: pChar); stdcall; external LibMySqldDll;
function mysql_thread_safe: longword; stdcall; external LibMySqldDll;

function  mysql_manager_init(con: PMYSQL_MANAGER): PMYSQL_MANAGER; stdcall; external LibMySqldDll;
function mysql_manager_connect(con: PMYSQL_MANAGER; const host, user, passwd: PChar; port: LongWord): TMYSQL_MANAGER; stdcall; external LibMySqldDll;
procedure mysql_manager_close(con: PMYSQL_MANAGER); stdcall; external LibMySqldDll;
function mysql_manager_command(con: PMYSQL_MANAGER; const cmd: PChar; cmd_len: Integer): Integer; stdcall; external LibMySqldDll;
function mysql_manager_fetch_line(con: PMYSQL_MANAGER; res_buf: PChar; res_buf_size: Integer): Integer; stdcall; external LibMySqldDll;

implementation

uses
  SysUtils,
  DateUtils,
  Windows;


//----------------------------------------------------------------------------------------
// Procedure  db_connect
// Arguments  database: string
// Created on 17 novembre 2003 - 19:03:32
// Updated on 17 novembre 2003 by Filippo Fadda <fadda@osway.com>
{:
   @author    Filippo Fadda <fadda@osway.com>
   @result    PMySQL
   @raises    ExcName ExcDescription
   @summary   SummaryText
   @desc      This function try to make a connection to the database.
   @bug       BugText
   @example   ExampleText
}
//----------------------------------------------------------------------------------------
function db_connect(database: string = ''): PMySQL;
begin
  Result := mysql_connect(nil, nil, nil, nil);
  if Result = nil then
    raise Exception.Create(rsNFOMySqlUnableToConnect)
  else
    if database <> '' then
      if mysql_select_db(Result, PChar(database)) <> 0 then
        raise Exception.Create(mysql_error(Result));
end;


//----------------------------------------------------------------------------------------
// Procedure  db_disconnect
// Arguments  MySQL: PMySQL
// Created on 17 novembre 2003 - 19:03:51
// Updated on 17 novembre 2003 by Filippo Fadda <fadda@osway.com>
{:
   @author    Filippo Fadda <fadda@osway.com>
   @result    None
   @raises    ExcName ExcDescription
   @summary   SummaryText
   @desc      This function release the connection.
   @bug       BugText
   @example   ExampleText
}
//----------------------------------------------------------------------------------------
procedure db_disconnect(MySQL: PMySQL);
begin
  if MySQL <> nil then begin
    mysql_close(MySQL);
    mysql_thread_end;
  end;
end;


//----------------------------------------------------------------------------------------
// Procedure  MySQLEncodeString
// Arguments  const Source: WideString
// Created on 27 agosto 2003 - 10:41:52
// Updated on 27 agosto 2003 by Cristiano Muzi <muzi@osway.com>
{:
   @author    Cristiano Muzi <muzi@osway.com>
   @result    String
   @raises    ExcName ExcDescription
   @summary   SummaryText
   @desc      This function converts a WideString into a UTF-8 encoded multibyte string,
              escaped and suitable to be inserted in mySQL tables.
   @bug       BugText
   @example   ExampleText
}
//----------------------------------------------------------------------------------------
function MySQLEncodeString(const MySQL: PMySql; const Source: WideString): string;
var
  Encoded, Escaped: String;
  Len: Integer;
begin
  Result := '';
  if Source = '' then
    exit;

  Len := WideCharToMultiByte(CP_UTF8, 0, PWideChar(Source), -1, nil, 0, nil, nil);
  if Len > 0 then begin
    SetLength(Encoded, Len - 1);
    WideCharToMultiByte(CP_UTF8, 0, PWideChar(Source), -1, PChar(Encoded), Len, nil, nil);
    SetLength(Escaped, Length(Encoded) * 2);
    Len := mysql_real_escape_string(MySQL, PChar(Escaped), PChar(Encoded), Length(Encoded));
    SetLength(Escaped, Len);
    Result := Escaped;
  end;
end;


//----------------------------------------------------------------------------------------
// Procedure  MySQLDecodeString
// Arguments  const Source: String
// Created on 27 agosto 2003 - 10:41:54
// Updated on 27 agosto 2003 by Cristiano Muzi <muzi@osway.com>
{:
   @author    Cristiano Muzi <muzi@osway.com>
   @result    WideString
   @raises    ExcName ExcDescription
   @summary   SummaryText
   @desc      This function converts a UTF-8 encoded multibyte string into a WideString.
   @bug       BugText
   @example   ExampleText
}
//----------------------------------------------------------------------------------------
function MySQLDecodeString(const Source: string): WideString;
var
  Decoded: WideString;
  Len: Integer;
begin
  Result := '';
  if Source = '' then
    exit;
  Len := MultiByteToWideChar(CP_UTF8, 0, PChar(Source), -1, nil, 0);
  if Len > 0 then begin
    SetLength(Decoded, Len - 1);
    MultiByteToWideChar(CP_UTF8, 0, PChar(Source), -1, PWideChar(Decoded), Len);
    Result := Decoded;
  end;
end;


//----------------------------------------------------------------------------------------
// Procedure  MySQLEncodeDate
// Arguments  const DateTime: TDateTime
// Created on 27 agosto 2003 - 14:45:31
// Updated on 27 agosto 2003 by Cristiano Muzi <muzi@osway.com>
{:
   @author    Cristiano Muzi <muzi@osway.com>
   @result    String
   @raises    ExcName ExcDescription
   @summary   SummaryText
   @desc      This function encodes a TDateTime to string suitable to be used with MySQL.
   @bug       BugText
   @example   ExampleText
}
//----------------------------------------------------------------------------------------
function MySQLEncodeDate(const DateTime: TDateTime): string;
var
  yy, mm, dd, hh, nn, ss, ms: Word;
begin
  DecodeDateTime(DateTime, yy, mm, dd, hh, nn, ss, ms);
  Result := Format('%.4d-%.2d-%.2d %.2d:%.2d:%.2d', [yy, mm, dd, hh, nn, ss]);
end;


//----------------------------------------------------------------------------------------
// Procedure  MySQLDecodeDate
// Arguments  const DateTime: String
// Created on 27 agosto 2003 - 14:45:19
// Updated on 27 agosto 2003 by Cristiano Muzi <muzi@osway.com>
{:
   @author    Cristiano Muzi <muzi@osway.com>
   @result    TDateTime
   @raises    ExcName ExcDescription
   @summary   SummaryText
   @desc      This function decodes a String as returned by MySQL into a TDateTime.
   @bug       BugText
   @example   ExampleText
}
//----------------------------------------------------------------------------------------
function MySQLDecodeDate(const DateTime: string): TDateTime;
var
  yy, mm, dd, hh, nn, ss: Word;
begin
  try
    yy := StrToInt(Copy(DateTime, 1, 4));
    mm := StrToInt(Copy(DateTime, 6, 2));
    dd := StrToInt(Copy(DateTime, 9, 2));
    hh := StrToInt(Copy(DateTime, 12, 2));
    nn := StrToInt(Copy(DateTime, 15, 2));
    ss := StrToInt(Copy(DateTime, 18, 2));
    Result := EncodeDateTime(yy, mm, dd, hh, nn, ss, 0);
  except
    Result := 0;
  end;
end;


//----------------------------------------------------------------------------------------
// Procedure  MySqlGetFieldValue
// Arguments  const Row: PMySql_Row; const Lengths: PMySql_Lengths; const Index: Integer
// Created on 27 agosto 2003 - 17:43:20
// Updated on 27 agosto 2003 by Cristiano Muzi <muzi@osway.com>
{:
   @author    Cristiano Muzi <muzi@osway.com>
   @result    WideString
   @raises    ExcName ExcDescription
   @summary   SummaryText
   @desc      This function returns the Index-th field from a result row of a query.
   @bug       BugText
   @example   ExampleText
}
//----------------------------------------------------------------------------------------
function MySqlGetFieldValue(const Row: PMySql_Row; const Lengths: PMySql_Lengths; const Index: Integer): WideString;
var
  Field: string;
begin
  SetLength(Field, Lengths[Index]);
  if Lengths[Index] > 0 then
    Move(Row[Index]^, Field[1], Lengths[Index]);
  Result := MySqlDecodeString(Field);
end;

end.
